JUCE: MenuBarModel Class Reference

JUCE

Classes | Public Member Functions | Static Public Member Functions | List of all members
MenuBarModel Class Referenceabstract
juce_gui_basics » menus

A class for controlling MenuBar components. More...

`#include <juce_MenuBarModel.h>`

Inheritance diagram for MenuBarModel:

## Classes
class | Listener
| A class to receive callbacks when a MenuBarModel changes. More...

## Public Member Functions
| MenuBarModel () noexcept
| ~MenuBarModel () override
| Destructor. More...
void | menuItemsChanged ()
| Call this when some of your menu items have changed. More...
void | setApplicationCommandManagerToWatch (ApplicationCommandManager *manager)
| Tells the menu bar to listen to the specified command manager, and to update itself when the commands change. More...
void | addListener (Listener *listenerToAdd)
| Registers a listener for callbacks when the menu items in this model change. More...
void | removeListener (Listener *listenerToRemove)
| Removes a listener. More...
virtual StringArray | getMenuBarNames ()=0
| This method must return a list of the names of the menus. More...
virtual PopupMenu | getMenuForIndex (int topLevelMenuIndex, const String &menuName)=0
| This should return the popup menu to display for a given top-level menu. More...
virtual void | menuItemSelected (int menuItemID, int topLevelMenuIndex)=0
| This is called when a menu item has been clicked on. More...
virtual void | menuBarActivated (bool isActive)
| This is called when the user starts/stops navigating the menu bar. More...
void | applicationCommandInvoked (const ApplicationCommandTarget::InvocationInfo &) override
void | applicationCommandListChanged () override
void | handleAsyncUpdate () override
void | handleMenuBarActivate (bool isActive)

## Static Public Member Functions
static void | setMacMainMenu (MenuBarModel *newMenuBarModel, const PopupMenu *extraAppleMenuItems=nullptr, const String &recentItemsMenuName=String())
| OSX ONLY - Sets the model that is currently being shown as the main menu bar at the top of the screen on the Mac. More...
static MenuBarModel * | getMacMainMenu ()
| OSX ONLY - Returns the menu model that is currently being shown as the main menu bar. More...
static const PopupMenu * | getMacExtraAppleItemsMenu ()
| OSX ONLY - Returns the menu that was last passed as the extraAppleMenuItems argument to setMacMainMenu(), or nullptr if none was specified. More...

## Detailed Description

A class for controlling MenuBar components.

This class is used to tell a MenuBar what menus to show, and to respond to a menu being selected.

See also
  MenuBarModel::Listener, MenuBarComponent, PopupMenu

## Constructor & Destructor Documentation

## ◆ MenuBarModel()

MenuBarModel::MenuBarModel | ( |  | ) |
| noexcept

## ◆ ~MenuBarModel()

MenuBarModel::~MenuBarModel | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ menuItemsChanged()

void MenuBarModel::menuItemsChanged | ( |  | ) |

Call this when some of your menu items have changed.

This method will cause a callback to any MenuBarListener objects that are registered with this model.

If this model is displaying items from an ApplicationCommandManager, you can use the setApplicationCommandManagerToWatch() method to cause change messages to be sent automatically when the ApplicationCommandManager is changed.

See also
  addListener, removeListener, MenuBarListener

## ◆ setApplicationCommandManagerToWatch()

void MenuBarModel::setApplicationCommandManagerToWatch | ( | ApplicationCommandManager * | manager | ) |

Tells the menu bar to listen to the specified command manager, and to update itself when the commands change.

This will also allow it to flash a menu name when a command from that menu is invoked using a keystroke.

## ◆ addListener()

void MenuBarModel::addListener | ( | Listener * | listenerToAdd | ) |

Registers a listener for callbacks when the menu items in this model change.

The listener object will get callbacks when this object's menuItemsChanged() method is called.

See also
  removeListener

## ◆ removeListener()

void MenuBarModel::removeListener | ( | Listener * | listenerToRemove | ) |

Removes a listener.

See also
  addListener

## ◆ getMenuBarNames()

virtual StringArray MenuBarModel::getMenuBarNames | ( |  | ) |
| pure virtual

This method must return a list of the names of the menus.

## ◆ getMenuForIndex()

virtual PopupMenu MenuBarModel::getMenuForIndex | ( | int | topLevelMenuIndex,
|  | const String & | menuName
| ) |  |
| pure virtual

This should return the popup menu to display for a given top-level menu.

Parameters

  topLevelMenuIndex | the index of the top-level menu to show
  menuName | the name of the top-level menu item to show

## ◆ menuItemSelected()

virtual void MenuBarModel::menuItemSelected | ( | int | menuItemID,
|  | int | topLevelMenuIndex
| ) |  |
| pure virtual

This is called when a menu item has been clicked on.

Parameters

  menuItemID | the item ID of the PopupMenu item that was selected
  topLevelMenuIndex | the index of the top-level menu from which the item was chosen (just in case you've used duplicate ID numbers on more than one of the popup menus)

## ◆ menuBarActivated()

virtual void MenuBarModel::menuBarActivated | ( | bool | isActive | ) |
| virtual

This is called when the user starts/stops navigating the menu bar.

Parameters

  isActive | true when the user starts navigating the menu bar

## ◆ setMacMainMenu()

static void MenuBarModel::setMacMainMenu | ( | MenuBarModel * | newMenuBarModel,
|  | const PopupMenu * | extraAppleMenuItems = `nullptr`,
|  | const String & | recentItemsMenuName = `String()`
| ) |  |
| static

OSX ONLY - Sets the model that is currently being shown as the main menu bar at the top of the screen on the Mac.

You can pass nullptr to stop the current model being displayed. Be careful not to delete a model while it is being used.

An optional extra menu can be specified, containing items to add to the top of the apple menu. (Confusingly, the 'apple' menu isn't the one with a picture of an apple, it's the one next to it, with your application's name at the top and the services menu etc on it). When one of these items is selected, the menu bar model will be used to invoke it, and in the menuItemSelected() callback the topLevelMenuIndex parameter will be -1. If you pass in an extraAppleMenuItems object then newMenuBarModel must be non-null.

If the recentItemsMenuName parameter is non-empty, then any sub-menus with this name will be replaced by OSX's special recent-files menu.

## ◆ getMacMainMenu()

static MenuBarModel * MenuBarModel::getMacMainMenu | ( |  | ) |
| static

OSX ONLY - Returns the menu model that is currently being shown as the main menu bar.

## ◆ getMacExtraAppleItemsMenu()

static const PopupMenu * MenuBarModel::getMacExtraAppleItemsMenu | ( |  | ) |
| static

OSX ONLY - Returns the menu that was last passed as the extraAppleMenuItems argument to setMacMainMenu(), or nullptr if none was specified.

## ◆ applicationCommandInvoked()

void MenuBarModel::applicationCommandInvoked | ( | const ApplicationCommandTarget::InvocationInfo & |  | ) |
| overridevirtual

Implements ApplicationCommandManagerListener.

## ◆ applicationCommandListChanged()

void MenuBarModel::applicationCommandListChanged | ( |  | ) |
| overridevirtual

Implements ApplicationCommandManagerListener.

## ◆ handleAsyncUpdate()

void MenuBarModel::handleAsyncUpdate | ( |  | ) |
| overridevirtual

Implements AsyncUpdater.

## ◆ handleMenuBarActivate()

void MenuBarModel::handleMenuBarActivate | ( | bool | isActive | ) |

The documentation for this class was generated from the following file:

- juce_MenuBarModel.h